/***************************************************************************
 *   Copyright (C) 2007 by Subhrendu Sarkar,,,   *
 *   ss3295@columbia.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// newer (non customized) versions of this file go to main_window.cc_new

// This file is for your program, I won't touch it again!

#include "config.h"
#include "main_window.hh"
#include <iostream>
#include <string>
#include <cv.h>
#include <cxcore.h>
#include <cvaux.h>
#include <highgui.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>


using namespace std;

#define DEMO

int sip_pua(void *param);
int g_busy_state;
pthread_mutex_t BusyState_mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t BusyState_cond = PTHREAD_COND_INITIALIZER;

pthread_mutex_t frameCapture_mutex = PTHREAD_MUTEX_INITIALIZER;


void *process2(void *param);


CvCapture  *capture = 0; // camera device 
IplImage   *frame   = 0; // camera frame
IplImage   *pOutFrame   = 0;
IplImage   *pdst   = 0; 
IplImage   *mdst  = 0;
IplImage   *temp1   = 0;
IplImage *greyImage = 0;
IplImage *movingAverage;
IplImage *difference;
IplImage *temp, *motionHistory;	


CvGaussBGModel *bg_model = NULL;	

CvGaussBGModel *bg_model_temp = NULL;
CvBGStatModel *bg_model_temp2;


//Lucas Kanade
IplImage *image = 0, *grey = 0, *prev_grey = 0,*pyramid = 0,*prev_pyramid = 0,*swap_temp;
CvPoint2D32f *points[2] = {0,0} , *swap_points;
char *status = 0;
int flags = 0;
CvSeq *track_contour = 0;
CvSeq *track_contour1 = 0;
int win_size = 10;


typedef struct Objects
{
   
    struct Objects*  next; /* next sequence block */
    CvPoint2D32f *pts32f;
    CvPoint *pts;		
    int    pt_count;             /* number of points in the object */
                  /* pointer to the points of the object */
    int track_add;	
}
Objects;

typedef struct Tracked_Points
{
   struct Objects*  next; /* next sequence block */
    
}
Tracked_Points;

void append(struct Objects **,int);
void del(struct Objects **,int);
void in_middle(struct Objects **,int,int);
int count(struct Objects *);
void display(struct Objects *);


void appendpts(struct Objects **q, CvPoint2D32f *pts32f, int no_pts)
{
	struct Objects *temp,*r;
	temp = *q;
	
	if(*q==NULL)
	{
		temp = (struct Objects *)malloc(sizeof(struct Objects));
		temp->track_add = 0;
		temp->pts = (CvPoint *) malloc(sizeof(CvPoint) * no_pts);
		temp->pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f) * no_pts);
		
		for(int j = 0; j < no_pts; j++)
		{
			temp->pts[j] = cvPointFrom32f(pts32f[j]);
			temp->pts32f[j] = pts32f[j];	
		}		
		temp->pt_count = no_pts;
		temp->next=NULL;
		*q=temp;
	}
	else
	{ 
		temp = *q;
		while(temp->next !=NULL)
		{
			temp=temp->next;
		}
		r = (struct Objects *)malloc(sizeof(struct Objects));
		r->track_add = 0;
		r->pts = (CvPoint *) malloc(sizeof(CvPoint) * no_pts);
		r->pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f) * no_pts);
		for(int j = 0; j < no_pts; j++)
		{
			r->pts[j] = cvPointFrom32f(pts32f[j]);
			r->pts32f[j] = pts32f[j];	
		}		
		r->pt_count = no_pts;	
		r->next=NULL;
		temp->next=r;
	
	}
}


void append(struct Objects **q,CvSeq **contour_ptr)
{
	struct Objects *temp,*r;
	temp = *q;
	CvSeq *lcontour_ptr = *contour_ptr;
	if(*q==NULL)
	{
		temp = (struct Objects *)malloc(sizeof(struct Objects));
		temp->track_add = 0;
		//temp->data=num;
		temp->pts = (CvPoint *) malloc(sizeof(CvPoint) * lcontour_ptr->total);
		temp->pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f) * lcontour_ptr->total);
		for(int j = 0; j < lcontour_ptr->total; j++)
		{
			temp->pts[j] = *CV_GET_SEQ_ELEM( CvPoint, lcontour_ptr, j);
			temp->pts32f[j] = cvPointTo32f(temp->pts[j]);	
		}		
		temp->pt_count = lcontour_ptr->total;
		temp->next=NULL;
		*q=temp;
	}
	else
	{ 
		temp = *q;
		while(temp->next !=NULL)
		{
			temp=temp->next;
		}
		r = (struct Objects *)malloc(sizeof(struct Objects));
		r->track_add = 0;
		r->pts = (CvPoint *) malloc(sizeof(CvPoint) * lcontour_ptr->total);
		r->pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f) * lcontour_ptr->total);
		for(int j = 0; j < lcontour_ptr->total; j++)
		{
			r->pts[j] = *CV_GET_SEQ_ELEM( CvPoint, lcontour_ptr, j);
			r->pts32f[j] = cvPointTo32f(temp->pts[j]);	
		}		
		r->pt_count = lcontour_ptr->total;	
		r->next=NULL;
		temp->next=r;
	
	}
}

void del(struct Objects **q,int)
{
	if(*q==NULL)
	{
		printf("\n\nEmpty Linked List.Cant Delete The Data.");
		return;
	}
	else
	{
		struct Objects *old,*temp;
		int flag=0;
		temp=*q;
		while(temp->next !=NULL)
		{
			old = temp;
			temp=temp->next;
			
		}

		if(temp==*q) /* First Node case */
			*q=temp->next; /* shifted the header node */
		else
			old->next=temp->next;

		free(temp->pts);
		free(temp->pts32f);
		free(temp);
		
		
	}
}

void delObject(struct Objects *q)
{
	if(q==NULL)
	{
		printf("\n\nEmpty Linked List.Cant Delete The Data.");
		return;
	}
	else
	{
		if(q->next != NULL)
		{
			delObject(q->next);
		} 
		else
		{
			
			free(q->pts);
			free(q->pts32f);
			free(q);
			q = NULL;
		}
		
	}
}





void merge(int numbers[], int temp[], int left, int mid, int right)
{
  int i, left_end, num_elements, tmp_pos;

  left_end = mid - 1;
  tmp_pos = left;
  num_elements = right - left + 1;

  while ((left <= left_end) && (mid <= right))
  {
    if (numbers[left] <= numbers[mid])
    {
      temp[tmp_pos] = numbers[left];
      tmp_pos = tmp_pos + 1;
      left = left +1;
    }
    else
    {
      temp[tmp_pos] = numbers[mid];
      tmp_pos = tmp_pos + 1;
      mid = mid + 1;
    }
  }

  while (left <= left_end)
  {
    temp[tmp_pos] = numbers[left];
    left = left + 1;
    tmp_pos = tmp_pos + 1;
  }
  while (mid <= right)
  {
    temp[tmp_pos] = numbers[mid];
    mid = mid + 1;
    tmp_pos = tmp_pos + 1;
  }

  for (i=0; i <= num_elements; i++)
  {
    numbers[right] = temp[right];
    right = right - 1;
  }
}

void m_sort(int numbers[], int temp[], int left, int right)
{
  int mid;

  if (right > left)
  {
    mid = (right + left) / 2;
    m_sort(numbers, temp, left, mid);
    m_sort(numbers, temp, mid+1, right);

    merge(numbers, temp, left, mid+1, right);
  }
}

void mergeSort(int numbers[], int temp[], int array_size)
{
  m_sort(numbers, temp, 0, array_size - 1);
}

main_window::main_window()
:m_GaussianBackground("Gaussian Background"), m_RunningAvgBackground("Running Average Background"),
m_checkTrackButton("Enable Tracking"), m_checkBackgroundOnce("Create Background Once"), m_TextViewCam(), m_TextViewPublish(),
m_StartButton("Start"),m_StopButton("Stop"),m_CloseButton("Close"), m_ParamControls(false,10)



{

	set_title("Automated Busy Discovery");
	set_border_width(0);

	Gtk::RadioButton::Group group = m_GaussianBackground.get_group();
	m_RunningAvgBackground.set_group(group);
	add(m_Box_Top); //window can contain onlyu one widget
	
	m_Box_Top.pack_start(m_ParamControls);
	m_Box_Top.pack_start(m_Separator1);
	m_Box_Top.pack_start(m_Algorithms);
	m_Box_Top.pack_start(m_Separator3);
	m_Box_Top.pack_start(m_Box_start);
	m_Box_Top.pack_start(m_TextBoxCam);
	m_Box_Top.pack_start(m_Separator4);
	m_Box_Top.pack_start(m_TextBoxPublish);
	

	m_Label1.set_text("Parameter Controls");	
	m_Label1.set_alignment(Gtk::ALIGN_LEFT, Gtk::ALIGN_TOP);
	m_ParamControls.pack_start(m_Label1);

	
	m_Label2.set_text("Algorithms");	
	m_Label2.set_alignment(Gtk::ALIGN_LEFT, Gtk::ALIGN_TOP);
	m_Algorithms.pack_start(m_Label2);
	m_Algorithms.pack_start(m_AlgBox);
	
	m_Algorithms.pack_start(m_Separator2);
	m_Algorithms.pack_start(m_TrackingBox);
	m_AlgBox.pack_start(m_GaussianBackground);
	m_AlgBox.pack_start(m_RunningAvgBackground);
	m_GaussianBackground.set_active();
	
	m_TrackingBox.pack_start(m_checkTrackButton);
	m_TrackingBox.pack_start(m_checkBackgroundOnce);
	m_checkTrackButton.set_active();
	
	m_Algorithms.set_sensitive(true);	
	m_Box_start.set_border_width(10);
	m_Box_start.set_border_width(10);
	
	m_TrackingEnable = 1;
	m_BackgroundMethod = 0;
	m_BackgroundOnceEnable = 0;
	
	m_Box_start.pack_start(m_StartButton);
	m_Box_start.pack_start(m_StopButton);
	m_Box_start.pack_start(m_CloseButton);
	k = 1;
	m_StartButton.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_button_clicked));
	m_checkTrackButton.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_Trackbutton_clicked));
	m_checkBackgroundOnce.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_BackgroundOncebutton_clicked));
	m_GaussianBackground.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_BackgroundGuassbutton_clicked));
	m_RunningAvgBackground.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_BackgroundRunningAvgbutton_clicked));
	

	m_StopButton.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_button_exit));	

	m_CloseButton.signal_clicked().connect(sigc::mem_fun(*this,
					&main_window::on_button_quit));	
	m_checkBackgroundOnce.set_sensitive(false);
	m_StopButton.set_sensitive(false);
	m_CloseButton.set_sensitive(false);
	FILE *fp; char sr[80]; char val[80];
	fp = fopen("config.txt","r+");
   	while (fscanf(fp, "%s", sr) != EOF)
	{
		if(strcmp("ContourSize",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",val);
				m_ContourSize = atoi(val);
			}


		}
		else if (strcmp("BackgroundFormationFrames",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",sr);
				m_BackgroundFormation = atoi(sr);
			}
		}
		else if (strcmp("ObjectDetectionRate",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",sr);
				m_ObjectDetectRate = atoi(sr);

			}
		}
		
		else if(strcmp("SIP_Address",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",m_sip_addr);
			
			}
		}
		else if(strcmp("SIP_PROXY",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",m_sip_proxy);
			}

		}
		else if(strcmp("SSC_NAME",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",m_ssc_name);
			}

		}
		else if(strcmp("SSC_CONTACT",sr) == 0)
		{
			fscanf(fp,"%s",sr);
			if(strcmp("=",sr) == 0)
			{
				fscanf(fp,"%s",m_ssc_contact);
			}

		}


	}
	fclose(fp);

	show_all_children();
	int stus1 = pthread_create(&pthr2,NULL,process2,(void *)this);
}

main_window::~main_window()
{
	
}

void free_thread(void *msgp)
{

	cvReleaseBGStatModel((CvBGStatModel**) &bg_model);
   	cvReleaseCapture( &capture );
   	cvDestroyWindow("Webcam");
	cvDestroyWindow("Background");
	cvDestroyWindow("Foreground");	
	#ifdef DEMO
	cvDestroyWindow("Blob");
	#endif
}

void free_thread1(void *msgp)
{
   	cvReleaseImage(&temp);
	cvReleaseImage(&difference);
	cvReleaseImage(&greyImage);
	cvReleaseImage(&movingAverage);
   	cvReleaseCapture( &capture );
   	cvDestroyWindow("Webcam");
}

void main_window::show_buttons()
{
	m_Algorithms.set_sensitive(true);
	m_StartButton.set_sensitive(true);

	m_StopButton.set_sensitive(false);
	m_CloseButton.set_sensitive(false);
}

void main_window::on_button_exit()
{
	std::cout << "Cancelling Threads" << std::endl;
	int rc = pthread_cancel(pthr1);	
	std::cout << "Cancelled Thread - Video Processing Unit " << rc << std::endl;
	sleep(1);
	
	std::cout << "EXIT thread - Video Processing Unit " << "" << std::endl;
	show_buttons();
}

void main_window::on_button_quit()
{
	on_button_exit();
	int rc,rc1;
	void *p;	
	rc = pthread_cancel(pthr2);
	pthread_mutex_lock(&BusyState_mutex);

	pthread_cond_signal(&BusyState_cond);
	pthread_mutex_unlock(&BusyState_mutex);	
	std::cout << "Cancelled Thread - SIP Publish " << rc << std::endl;
	sleep(1);
	rc1  = pthread_join(pthr2, &p);
	std::cout << "EXIT thread - - SIP Publish " << rc1 << std::endl;
	hide();
}

bool main_window::quit(GdkEventAny *ev)
{
	return 0;
}

void main_window::on_BackgroundOncebutton_clicked()
{
	m_BackgroundOnceEnable = (m_BackgroundOnceEnable == 1) ? 0 :1;
}
void main_window::on_Trackbutton_clicked()
{
	m_TrackingEnable = (m_TrackingEnable == 1) ? 0 :1;
}

void main_window:: on_BackgroundGuassbutton_clicked()
{
	m_checkBackgroundOnce.set_sensitive(false);
	m_checkTrackButton.set_sensitive(true);
	m_checkTrackButton.set_active();
	m_BackgroundMethod = 0;
}
void main_window::on_BackgroundRunningAvgbutton_clicked()
{
	m_checkBackgroundOnce.set_sensitive(true);
	m_checkTrackButton.set_sensitive(false);
	m_BackgroundMethod = 1;
}




void *process1(void *param)
{
	int last_state,last_type,i = 0;
	int s;
	int ObjectDetectionRate, BackgroundFormationRate, ContourSize;
	main_window *win = (main_window *)param;
	time_t start,end;
	double elapsed = 0;
	int clkfirst = 1;

	int km;
  	
	if(win->m_BackgroundMethod == 1)
	{
		int objects_No[1000];
		int tmp_Objs_No[1000];
		int object_frame_no = -1;
		int min_obj, max_obj,median_obj,mode_obj;
	

		std::cout << "Camera Starts\n" << std::endl;
	// Initialize web camera 	    
		capture = cvCaptureFromCAM(0);
		if( !capture ){
			fprintf(stderr,"Could not initialize capturing. Exiting...\n");
			return 0;//-1;
		}
		pthread_cleanup_push(free_thread1, NULL);
		cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH,320);
		cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT,240);
	
		cvSetCaptureProperty(capture, CV_CAP_PROP_BRIGHTNESS,0.4);
	
		
		int Numframes = 0 ;
	// Create the Browser Window
		cvNamedWindow( "Webcam", 1 );
		cvMoveWindow("Webcam", 30, 0);

		CvRect bndRect = cvRect(0,0,0,0);
		CvPoint pt1,pt2;
		CvFont font;
		
		int prevX = 0;
		int numPeople = 0;
		char wow[65];
		int avgX = 0;
		bool first = true;
		int closestToLeft = 0;
		int closestToRight;
		int contourpresent = 0;
		cout << sizeof(char *) << endl;
		while((frame) = cvQueryFrame( capture ))
		{	

			Numframes++;
			std::cout <<"Numframes" << Numframes<< /*"Detected " << no_objects << */ std::endl;
			contourpresent = 0;

			if(!frame)
				break;
			//Images to use in my program
			if(!greyImage)
			{
				greyImage = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U, 1);
				closestToRight = frame->width;
				movingAverage = cvCreateImage(cvGetSize(frame),IPL_DEPTH_32F, 3);
				motionHistory = cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U, 3);
			}
			
			if(first)
			{
				difference = cvCloneImage(frame);
				temp = cvCloneImage(frame);
				cvConvertScale(frame, movingAverage, 1.0, 0.0);
				first = false;
			}
			else
			{
				if(win->m_BackgroundOnceEnable == 0)
				{
					pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, &last_type);
					s = pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, &last_state);
					cvRunningAvg(frame, movingAverage, 0.020, NULL);
					pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &last_type);

				}

				if(Numframes < win->m_BackgroundFormation)
				{
					if(win->m_BackgroundOnceEnable == 1)
					{
						pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, &last_type);
						s = pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, &last_state);
						cvRunningAvg(frame, movingAverage, 0.020, NULL);
						pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &last_type);
					}
					continue;
				}
			}	
			cvConvertScale(movingAverage, temp, 1.0, 0.0);
			cvAbsDiff(frame, temp, difference);
			cvCvtColor(difference, greyImage, CV_RGB2GRAY);

			cvThreshold(greyImage, greyImage, 70,255, CV_THRESH_BINARY);

			cvDilate(greyImage, greyImage, 0, 18);
			cvErode(greyImage, greyImage, 0, 10);

			CvMemStorage *storage = cvCreateMemStorage(0);
			CvSeq *contour = 0;
			cvFindContours(greyImage, storage, &contour, sizeof(CvContour), CV_RETR_CCOMP, CV_CHAIN_APPROX_SIMPLE);
			numPeople = 0;
			for( ; contour != 0; contour = contour->h_next )
			{		
					
					contourpresent = 1;
					//Get a bounding rectangle around the moving object.
					//Get an average X position of the moving contour.
					avgX = (pt1.x + pt2.x) / 2;
					if((fabs(cvContourArea(contour, CV_WHOLE_SEQ ))) >= win->m_ContourSize)
					{
						bndRect = cvBoundingRect(contour, 0);
						pt1.x = bndRect.x;
						pt1.y = bndRect.y;
						pt2.x = bndRect.x + bndRect.width;
						pt2.y = bndRect.y + bndRect.height;
						
						numPeople++;
						cout << "numPeople increased" << endl;
						//Draw the bounding rectangle around the detected object.
						cvRectangle(frame, pt1, pt2, CV_RGB(255,0,0), 1);
					}


/* The following section of code is disabled because it was an experiment which was carried out - The code tries to detect the entry of an individual in the scene by detecting contours on the edge of the frame */
#if 0
					//If the contour is within the edges of frame...
					if(avgX > 90 && avgX < 250)
					{
						//If the the previous contour was within 2 of the left boundary...
						if(closestToLeft >= 88 && closestToLeft <= 90)
						{
							//If the current X position is greater than the previous...
							if(avgX > prevX)
							{
								//Increase the number of people.
								numPeople++;
								cout << "numPeople increased" << endl;
								//Reset the closest object to the left indicator.
								closestToLeft = 0;
							}
						}
						//else if the previous contour was within 2 of the right boundary...
						else if(closestToRight >= 250 && closestToRight <= 252)
						{
							//If the current X position is less than the previous...
							if(avgX < prevX)
							{
								//Increase the number of people.
								numPeople++;
								cout << "numPeople increased" << endl;
								//Reset the closest object to the right counter.
								closestToRight = 320; 
							}
						}
		
						//Draw the bounding rectangle around the moving object.
						cvRectangle(frame, pt1, pt2, CV_RGB(255,0,0), 1);
					}
					
					//If the current object is closer to the left boundary but still not across
					//it, then change the closest to the left counter to this value.
					if(avgX > closestToLeft && avgX <= 90)
					{
							closestToLeft = avgX;
					}
		
					//If the current object is closer to the right boundary but still not across
					//it, then change the closest to the right counter to this value.
					if(avgX < closestToRight && avgX >= 250)
					{
							closestToRight = avgX;
					}
		
					//Save the current X value to use as the previous in the next iteration.
					prevX = avgX;	
#endif		
			}
			
			if(contourpresent == 0)
				numPeople = 0;
			cout << "numPeople " << numPeople << " Contour Present " << contourpresent <<endl;
			objects_No[object_frame_no] = numPeople;
		
			if(object_frame_no == win->m_ObjectDetectRate)
			{
				mergeSort(objects_No,tmp_Objs_No,(win->m_ObjectDetectRate+1));
				min_obj = objects_No[0];
				max_obj = objects_No[win->m_ObjectDetectRate];
				median_obj = objects_No[win->m_ObjectDetectRate/2];
				
				int tmp_mode[win->m_ObjectDetectRate];	
				for(int mn = 0; mn <  win->m_ObjectDetectRate; mn++)
				{
					tmp_mode[mn] = -1;
				}
				int j = 0;
				for(int mn = 0; mn <  win->m_ObjectDetectRate; mn++)
				{
					if(mn == 0)				
						tmp_mode[0] = 1;
					else
					{
						if(objects_No[mn] == tmp_mode[j])	 
							tmp_mode[j]++;
						else
						{
							j++;
							tmp_mode[j] = objects_No[mn];
						}	 
					}	
	
				}
				j = 0;
				int max = 0;
				int no_Obj;
				while((tmp_mode[j] != -1) && (j >win->m_ObjectDetectRate - 1))
				{
					if(j > 0)
					{
						if(tmp_mode[j] > max)
						{
							max = tmp_mode[j];
							no_Obj = j;
						}
					}
					else
					{
						max = max = tmp_mode[j];
						no_Obj = j;	
					}
	
					j++;
				}			
				
				
				std::cout << "min = " << min_obj << " MAX = " << max_obj << " MEDIAN = " << median_obj <</* " MODE = " << no_Obj << "\n %age- " << (double)max/60 << "\n" <<*/ std::endl;
				std::cout << "Processing Frame rate : " << (double)win->m_ObjectDetectRate/elapsed << std::endl;
				elapsed = 0; 
				clkfirst = 1;
				
				{
					pthread_mutex_lock(&BusyState_mutex);
					g_busy_state = (min_obj >= 2) ? 1 : 0;
						
					pthread_cond_signal(&BusyState_cond);
					pthread_mutex_unlock(&BusyState_mutex);
				}
				object_frame_no = -1;
			}
			else
			{
				object_frame_no++;
			}
			

			sleep(1);	

			pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &last_type); 
			//Show the frame.
			cvShowImage("Webcam", frame);
			time (&end);
			
			if(!clkfirst)
				elapsed += difftime (end,start);;/**/

			time (&start);
			clkfirst = 0;

		}
		pthread_cleanup_pop(0);
		
	}
	else
	{
	
		Objects *Detected_Objects = NULL;
		Objects *prev_Detected_Objects = NULL;
		Objects *Tracked_Objects = NULL;
		int start = 1;	
		int no_objects = 0;
		int prev_no_objects = 0;
		int need_to_init = 1;
		CvMemStorage *temp_storage = cvCreateMemStorage(0);
		CvMemStorage *storage = cvCreateMemStorage(0);
		CvMemStorage *temp_storage1 = cvCreateMemStorage(0);
		CvMemStorage *temp_storage2 = cvCreateMemStorage(0);
		CvSeq *contour = 0;
		CvSeq* it_contours;
		CvSeq new_Contour;
		#ifdef DEMO
		IplImage   *dst  = 0;
		#endif
		int objects_No[1000];
		int tmp_Objs_No[1000];
		int object_frame_no = -1;
		int min_obj, max_obj,median_obj,mode_obj;
	
		CvPoint2D32f *Tracked_OBJ_pts32f = NULL;
		CvPoint2D32f *ONLY_Tracked_OBJ_pts32f = NULL;
		CvPoint2D32f *AllDetected_pts32f = NULL;
		int track_count;
		int first_detection = 0;
	
		IplConvKernel*kernel = cvCreateStructuringElementEx( 10, 10, 5, 5,CV_SHAPE_ELLIPSE);
		std::cout << "Camera Starts\n" << std::endl;
	// Initialize web camera 	    
		capture = cvCaptureFromCAM(0);
		if( !capture ){
			fprintf(stderr,"Could not initialize capturing. Exiting...\n");
			return 0;//-1;
		}
		
	char *msgp;
	msgp = (char *)malloc(10);
		pthread_cleanup_push(free_thread, NULL);
	// Set resolution
		cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH,320);
		cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT,240);
	
		cvSetCaptureProperty(capture, CV_CAP_PROP_BRIGHTNESS,0.4);
		int Numframes = 0 ;
	// Create the Browser Window
		cvNamedWindow( "Webcam", 1 );
		cvNamedWindow( "Background", 1 );
		cvNamedWindow( "Foreground", 1 );
		#ifdef DEMO
		cvNamedWindow( "Blob", 1 );
		#endif
		cvMoveWindow("Webcam", 30, 0);
		cvMoveWindow("Background", 360, 0);
		cvMoveWindow("Foreground", 690, 0);
		#ifdef DEMO
		cvMoveWindow( "Blob", 1020,0 );
		#endif

		// Infinite main loop
	while((frame) = cvQueryFrame( capture ))
	{
		
		//pthread_mutex_lock(&frameCapture_mutex);
		#ifdef DEMO
		dst  = 0;
		#endif
		#ifdef DEMO
			dst = cvCreateImage(cvGetSize(frame), 8 , 3);
		#endif
		Numframes++;


		if(!frame)
			break;
	// On first time call: Create greyscale image of correct size
	
		if(!image)
		{
			image = cvCreateImage(cvGetSize(frame), 8, 3);
			image->origin = frame->origin;
			grey = cvCreateImage(cvGetSize(frame), 8, 1);
			prev_grey = cvCreateImage(cvGetSize(frame), 8, 1);
			pyramid = cvCreateImage(cvGetSize(frame), 8, 1);
			prev_pyramid = cvCreateImage(cvGetSize(frame), 8, 1);
			status = (char *)cvAlloc(500);
			flags = 0;
	
		}
			
		if(1 == Numframes)
		{
			if(1 == start)
			{
				bg_model = (CvGaussBGModel *)cvCreateGaussianBGModel(frame);
				pOutFrame =  cvCreateImage(cvSize(frame->width, frame->height), IPL_DEPTH_8U,1);
				pdst = cvCreateImage(cvSize(frame->width, frame->height), IPL_DEPTH_8U,1);
				start = 0;
			}	
		}
		else
		{
			
			pthread_setcanceltype(PTHREAD_CANCEL_DEFERRED, &last_type);
			s = pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, &last_state);
			cvUpdateBGStatModel(frame,(CvBGStatModel *)bg_model);
			pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &last_type);
			std::cout <<"Numframes" << Numframes<< /*"Detected " << no_objects << */ std::endl;
			if ((Numframes <= win->m_BackgroundFormation) && (0 == start))
			{
				if(win->m_BackgroundFormation == Numframes)
					start = 2;
				continue;
			}
			if(object_frame_no == win->m_ObjectDetectRate)
			{
				mergeSort(objects_No,tmp_Objs_No, (win->m_ObjectDetectRate+1));
				min_obj = objects_No[0];
				max_obj = objects_No[ win->m_ObjectDetectRate];
				median_obj = objects_No[ win->m_ObjectDetectRate/ 2 ];
				
				int tmp_mode[ win->m_ObjectDetectRate];	
				for(int mn = 0; mn <  win->m_ObjectDetectRate; mn++)
				{
					tmp_mode[mn] = -1;
				}
				int j = 0;
				for(int mn = 0; mn <  win->m_ObjectDetectRate; mn++)
				{
					if(mn == 0)				
						tmp_mode[0] = 1;
					else
					{
						if(objects_No[mn] == tmp_mode[j])	 
							tmp_mode[j]++;
						else
						{
							j++;
							tmp_mode[j] = objects_No[mn];
						}	 
					}	
				}
				j = 0;
				int max = 0;
				int no_Obj;
				while((tmp_mode[j] != -1) && (j > win->m_ObjectDetectRate - 1))
				{
					if(j > 0)
					{
						if(tmp_mode[j] > max)
						{
							max = tmp_mode[j];
							no_Obj = j;
						}
					}
					else
					{
						max = max = tmp_mode[j];
						no_Obj = j;	
					}
	
					j++;
				}			
				std::cout << "No  Of Objects - Min = " << min_obj << " MAX = " << max_obj << " MEDIAN = " << median_obj << " MODE = " << no_Obj << /*"\n %age- " << (double)max/60 << "\n" << */std::endl;
				
				{
					pthread_mutex_lock(&BusyState_mutex);
					g_busy_state = (min_obj >= 2) ? 1 : 0;
						
					pthread_cond_signal(&BusyState_cond);
					pthread_mutex_unlock(&BusyState_mutex);
				}
				object_frame_no = -1;
			}
			else
			{
				object_frame_no++;
			}
	
			cvDilate(bg_model->foreground, pOutFrame, kernel, 2);
			cvErode(pOutFrame,pdst,kernel,1);
			
			cvFindContours(pdst, storage, &contour, sizeof(CvContour), CV_RETR_TREE/*CV_RETR_EXTERNAL*/, CV_CHAIN_APPROX_SIMPLE); //CV_RETR_CCOMP
			if(contour != NULL)
				contour = cvApproxPoly(contour, sizeof(CvContour), temp_storage1, CV_POLY_APPROX_DP, 3, 1);
	
			int i = 0, cnt = -1, contour_cnt = 0;
			int m = 0;int count;
			int remove[20];
			no_objects = 0;
			it_contours = contour;
			for (; it_contours != 0 ; contour_cnt++ )
			{
				if((fabs(cvContourArea(it_contours, CV_WHOLE_SEQ ))) >= win->m_ContourSize)
				{
				#ifdef DEMO
					cvDrawContours(dst, it_contours, CV_RGB(rand(), rand(), rand()), CV_RGB(rand(), rand(), rand()), -1, 1, 8);
				#endif	
					append(&Detected_Objects,&it_contours);
					i++;
					no_objects++;
					it_contours = it_contours->h_next;
				}
				else
				{
					cnt++;
					remove[cnt] = contour_cnt;
					it_contours = it_contours->h_next;
				}
			}
			
			Objects *temp_Detected_Objects = Detected_Objects; 
			int t_pts = 0;
			while(temp_Detected_Objects != NULL)
			{
				t_pts = t_pts +  temp_Detected_Objects->pt_count;
				temp_Detected_Objects = temp_Detected_Objects->next;	
			}
			
			if(AllDetected_pts32f != NULL)
			{
				free(AllDetected_pts32f);
				AllDetected_pts32f = NULL;
			}
			AllDetected_pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f ) * t_pts) ;		
			temp_Detected_Objects = Detected_Objects; 
			int t = 0;
			while(temp_Detected_Objects != NULL)
			{
				for(int p = 0; p  < temp_Detected_Objects->pt_count; p++,t++)
				{
					AllDetected_pts32f[t].x = temp_Detected_Objects->pts32f[p].x;
					AllDetected_pts32f[t].y = temp_Detected_Objects->pts32f[p].y; 
				}
				temp_Detected_Objects = temp_Detected_Objects->next;
			}
	
			cvCopy(frame, image, 0);
			cvCvtColor(image, grey, CV_BGR2GRAY);
	
		#if 1
		if(win->m_TrackingEnable == 1)
		{
			int n, h;
			if(prev_Detected_Objects != NULL) 
			{
					Objects *temp_prev_Detected_Objects = prev_Detected_Objects;
					while(temp_prev_Detected_Objects!= NULL) 
					{
						if(Tracked_OBJ_pts32f != NULL)
						{
							free(Tracked_OBJ_pts32f);
	
							Tracked_OBJ_pts32f = NULL;
						}
						if(ONLY_Tracked_OBJ_pts32f != NULL)
						{
							free(ONLY_Tracked_OBJ_pts32f);
							ONLY_Tracked_OBJ_pts32f = NULL;
						}
						Tracked_OBJ_pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f ) * prev_Detected_Objects->pt_count) ;
						
						ONLY_Tracked_OBJ_pts32f = (CvPoint2D32f *) malloc(sizeof(CvPoint2D32f ) * prev_Detected_Objects->pt_count);
		
						cvCalcOpticalFlowPyrLK(prev_grey, grey, prev_pyramid, pyramid,
						prev_Detected_Objects->pts32f,
						Tracked_OBJ_pts32f, 
						prev_Detected_Objects->pt_count,
						cvSize(win_size,win_size), 3, status, 0, cvTermCriteria(CV_TERMCRIT_ITER|CV_TERMCRIT_EPS,20, 0.03), flags);
						flags |= CV_LKFLOW_PYR_A_READY; 
					
						int status_cnt = 0;
						for(n = h = 0; n < prev_Detected_Objects->pt_count; n++)
						{
							if(!status[n])
							{
								status_cnt++;	
								continue;
							}
							else
							{
								cvCircle(image,cvPointFrom32f(Tracked_OBJ_pts32f[n]),3, CV_RGB(0,255,0), -1, 8, 0);
								ONLY_Tracked_OBJ_pts32f[h].x = Tracked_OBJ_pts32f[n].x;
								ONLY_Tracked_OBJ_pts32f[h].y = Tracked_OBJ_pts32f[n].y;
								h++;
							}
						}

						//search the tracked pts with detected objects and add the tracked object pts if it is not the same pts tracked
						if(status_cnt <= 0.7 * prev_Detected_Objects->pt_count)
						{
	
							int no_same = 0;
							int trackpts_add = 0;
							for(int k = 0; k < h; k++)
							{
								for(int p = 0; p < t_pts; p++)
								{
									if ((AllDetected_pts32f[p].x <= (ONLY_Tracked_OBJ_pts32f[k].x+2))   && (AllDetected_pts32f[p].x >= (ONLY_Tracked_OBJ_pts32f[k].x-2)) &&		 (AllDetected_pts32f[p].y <= (ONLY_Tracked_OBJ_pts32f[k].y+2))   && (AllDetected_pts32f[p].y >= (ONLY_Tracked_OBJ_pts32f[k].y-2)) )
									{
										no_same++;
										break;	
									}	
	
								}
							}
	
							if(no_same == 0)
							{
								int hjk = 0;
							}	
	
							if(no_same >= (90 * h)/100)
							{
								
								trackpts_add = 0;
								break;
							}
							else
							{
								trackpts_add = 1;
							}
					
							if(1 == trackpts_add)
							{
								appendpts(&Detected_Objects,ONLY_Tracked_OBJ_pts32f, h);
								Objects *temp_Objects = Detected_Objects;
								int number = 0;
								while(temp_Objects != NULL)
								{
									number++;
									temp_Objects = temp_Objects->next;	
								}
								no_objects = number;
							}	
							
						}
						track_count = h;
						temp_prev_Detected_Objects = temp_prev_Detected_Objects->next;
					}
			}
		}
	#endif
			if(no_objects > 0)
			{
				if(prev_Detected_Objects != NULL)
				{
					//delete and free memory of prev_Detected_Objects
					delObject(prev_Detected_Objects);
						
					prev_Detected_Objects = NULL;
				}
				if(Detected_Objects == NULL)
					int mk = 0;
	
				prev_Detected_Objects = Detected_Objects;
				prev_no_objects = no_objects;
				if(prev_no_objects > 5)
				{
					int hj = 0;
					first_detection = 1;		
				}
				Detected_Objects = NULL;
				first_detection = 1;
			}
			CV_SWAP(prev_grey, grey, swap_temp);
			CV_SWAP(prev_pyramid, pyramid, swap_temp);

			objects_No[object_frame_no] = no_objects;
			cvShowImage("Webcam", frame);
			cvShowImage("Background", bg_model->background);	
			cvShowImage("Foreground",image/*temp bg_model->foreground*/);
			#ifdef DEMO
			cvShowImage("Blob", dst);
			#endif
		}
		sleep(1);	

		pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &last_type); 
	}
		pthread_cleanup_pop(0);
	}
    

}

void *process2(void *param)
{
	sip_pua(param);
}

void main_window::disable_buttons()
{
	m_Algorithms.set_sensitive(false);
	m_StartButton.set_sensitive(false);
	m_StopButton.set_sensitive(true);
	m_CloseButton.set_sensitive(true);

}
void main_window::on_button_clicked()
{

	g_busy_state = 0;
	disable_buttons();
	int stus = pthread_create(&pthr1,NULL,process1,(void *)this);
	return;
}
