/***************************************************************************
 *   Copyright (C) 2007 by Subhrendu Sarkar    *
 *   ss3295@columbia.edu   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// newer (non customized) versions of this file go to main_window.hh_new

// you might replace
//    class foo : public foo_glade { ... };
// by
//    typedef foo_glade foo;
// if you didn't make any modifications to the widget

#ifndef _MAIN_WINDOW_HH
#  include "main_window_glade.hh"
#  define _MAIN_WINDOW_HH
#include <pthread.h>

#include <gtkmm.h>
#include <gtkmm/button.h>
class main_window : public main_window_glade
{
	protected :
		virtual void on_button_clicked();
		virtual void on_button_exit();
		virtual void on_button_quit();
		virtual void on_Trackbutton_clicked();
		virtual void on_BackgroundGuassbutton_clicked();
		virtual void on_BackgroundRunningAvgbutton_clicked();
		virtual void on_BackgroundOncebutton_clicked();

		Gtk::Label m_Label1, m_Label2, m_Label3, m_Label4,m_Label5,m_Label6,m_Label7, m_Label8;
		Gtk::Button m_button,m_button_Exit,m_button_Algorithm;
		Gtk::VBox m_Box_Top;
		Gtk::HBox m_Top_Box1H;
		Gtk::VBox m_ParamControls;
		Gtk::HBox m_NumberofFramesWindow;
		Gtk::HBox m_ObjectDetectRateWindow;
		Gtk::HBox m_ContourSizeWindow;
		Gtk::ScrolledWindow m_ScrolledWindow;
		Gtk::TextView m_TextView1,m_TextView2,m_TextView3;
		Glib::RefPtr<Gtk::TextBuffer> m_refTextBuffer1, m_refTextBuffer2,m_refTextBuffer3;

		Gtk::HSeparator m_Separator1,m_Separator4;
		Gtk::HBox m_Algorithms;
		Gtk::VBox m_AlgBox, m_TrackingBox;
		Gtk::VBox m_Box1;
		Gtk::RadioButton m_GaussianBackground, m_RunningAvgBackground;
		Gtk::VSeparator m_Separator2;
		
		Gtk::VBox m_Box2;
		Gtk::CheckButton m_checkTrackButton, m_checkBackgroundOnce;
		
		Gtk::HSeparator m_Separator3;		
		Gtk::HBox m_Box_start, m_Box_stop, m_Box_close;
		Gtk::Button m_StartButton,m_StopButton,m_CloseButton;
		Gtk::VBox m_TextBoxCam, m_TextBoxPublish ;
		Gtk::HBox m_Top_Box2H;
		
		pthread_t pthr1,pthr2;
	public:
		int k;
		int m_TrackingEnable, m_BackgroundOnceEnable;
		int m_BackgroundMethod; // 0 - Gaussian Background; 1: running Average
		Gtk::ScrolledWindow m_ScrolledWindow1,m_ScrolledWindow2;
		Gtk::TextView m_TextViewCam, m_TextViewPublish;
		Glib::RefPtr<Gtk::TextBuffer> m_refTextBufferCam,m_refTextBufferPublish;
		char m_sip_addr[80], m_sip_proxy[80], m_ssc_name[80], m_ssc_contact[80] ;

		int m_BackgroundFormation, m_ObjectDetectRate, m_ContourSize;
		
	public:
		main_window();
		virtual ~main_window();
        bool quit(GdkEventAny *ev);
		void show_buttons();
		void disable_buttons();

};

#endif
